# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Hydra.
# 
# Hydra is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Hydra is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Hydra.  If not, see <http://www.gnu.org/licenses/>.

##from view_holder import ViewHolder
from searcher import *
from undo_controler import *
from edit_frames import *
from view_holder import ViewHolder
import copy
from time import time

class Dict(Frame, Context):
	def create_widgets(self):
		
		self.search_view_holder = None

		self.editor = Editor(self, self)
		self.attach(self.editor, VM.Search|VM.Select|VM.Edit|VM.Save)
		self.editor.pack(side = BOTTOM, fill = X)
		
		self.view_holder = ViewHolder(self, self)
##		self.view_holders = (self.view_holder, self.search_view_holder)
		
		
		top_frame = Frame(self)
		name_label = Label(top_frame, text = self.name)
		name_label.pack(side = "left")
		
		undo_controler = UndoControler(top_frame, self.history())
		undo_controler.pack(side = 'left')
		
		close_button = Button(top_frame, text = "x", command = self.close)
		close_button.pack(side = "right")
		
		top_frame.pack(fill = "x")
		
		self.view_holder.pack(expand = 1, fill = BOTH)
		self.attach(self.view_holder, VM.All)
	def set_view_holder(self, vh = None):
		if vh:
			self.search_view_holder = vh
			self.view_holder.pack_forget()
			self.search_view_holder.pack(expand = 1, fill = BOTH)
		elif self.search_view_holder:
				self.search_view_holder.pack_forget()
				self.view_holder.pack(expand = 1, fill = BOTH)
				self.search_view_holder = None
##	def switch(self):
##		next = (self.current_vh + 1) % 2
##		self.view_holders[self.current_vh].pack_forget()
##		self.view_holders[next].pack(expand = 1, fill = BOTH)
##		self.current_vh = next
	def history(self):
		return self._history
	def __init__(self, lang, name, holder, parent=None):
		Frame.__init__(self, parent, width=100)
		Context.__init__(self)
		self.name = name
		self.lang = lang
		self.ling = None
		self.holder = holder
		self._history = History()
		self.commands = []
##		self.current_vh = HolderState.Main
		self.create_widgets();
	def close(self):
		self.holder.remove_dict(self)
	def enabled(self):
		return self.ling == None or not self.ling.editable()
# Observer pattern
	#As client
	def set_notify(self, message):
		#print "set_notify", ling
##		ling = message.data
##		if not ling or isinstance(ling, Ling):
		self.ling = message.data
		self.notify(message)
	def refresh(self, message):
		print "dict refresh", message.data
		begin = time()
		ling = message.data
		if self.enabled():
			if ling:
				ling = ling.cloning(self.lang)
				new_message = message.copy()
				new_message.data = ling
				refresh_command = RefreshCommand(self.history(), self, new_message)
				refresh_command.redo()
		end = time()
#		print (end - begin)

	def _refresh(self, message):
		if message.type & VM.Select:
			self.set_notify(message)
		else:
			self.notify(message)
	def connect_popup(self, popup):
		self.editor.connect_popup(popup)
	def memento(self):
		return (self.ling, self.view_holder.memento(), self.editor.memento())
	def set_memento(self, memento):
		self._refresh(VMessage(memento[0], VM.Select, [self.view_holder, self.editor]))
		self.view_holder.set_memento(memento[1])
		self.editor.set_memento(memento[2])
	
	def command(self):
##		return self.commands[-1]
		return self.history().top()
	def edit_ling(self):
		h = self.history()
		ling = self.ling
		edit_command = MacroCommand2(h)
##		self.commands.append(edit_command)
		
		edit_command.append(EditLingCommand(h, ling))
		edit_command.append(RefreshCommand(h, self, VMessage(ling, VM.Edit)))

		edit_command.redo()
	def save_ling(self, sling = None):
		err = self.ling.check()
		if err:
			showinfo("Save", err, parent = self)
			return
		self._save_ling(sling)
	def _save_ling(self, sling):
		h = self.history()
		ling = self.ling
		save_ling_command = MacroCommand(h)
		
		save_command = MacroCommand2(h)
		save_command.append(SaveLingCommand(h, ling))
		save_command.append(RefreshCommand(h, self, VMessage(ling, VM.Save)))
		#save_command.append(HideFrameCommand(h, self))
		save_ling_command.append(save_command)
		if sling:
			edit_command = MacroCommand2(h)
			edit_command.append(EditLingCommand(h, sling))
			edit_command.append(RefreshCommand(h, self, VMessage(sling, VM.Edit|VM.Select, [self.editor])))
			save_ling_command.append(edit_command)
##		self.commands.pop()
		save_ling_command.redo()
	def add_rel(self, rel, new_ling):
		h = self.history()
		add_rel_command = MacroCommand2(h)
		add_rel_command.append(AddRelCommand(h, rel, self.ling, new_ling))
		add_rel_command.append(RefreshCommand(h, self, VMessage(self.ling, VM.Save)))
		
		add_rel_command.redo()
	def add_creational_rel(self, rel):
		h = self.history()
		add_creational_rel_command = NewCreationalLingCommand(h, self, self.ling, rel)
		add_creational_rel_command.redo()
	def searcher(self, rel):
		h = self.history()
		self.searcher_command = MacroCommand(h)
		self.searcher_command.append(RefreshCommand(h, self, VMessage(rel, VM.Search)))
		self.searcher_command.redo()
	def delete_rel(self, rel, ling):
		h = self.editor.history()
		delete_rel_command = MacroCommand2(h)
		del_rel_command = MacroCommand(h)
		del_rel_command.append(DeleteRelCommand(h, rel, self.ling, ling))
		if rel.is_(RelChars.NewCreational):
			del_rel_command.append(DeleteLingAndRelationsCommand(h, ling))
		delete_rel_command.append(del_rel_command)
		delete_rel_command.append(RefreshCommand(h, self, VMessage(self.ling)))
			
		delete_rel_command.redo()
	def delete_synset(self):
		h = self.history()
		delete_synset_command = MacroCommand2(h)
		delete_synset_command.append(DeleteSynsetCommand(h, self.ling))
		delete_synset_command.append(RefreshCommand(h, self, VMessage(None, VM.Select)))
		delete_synset_command.redo()
	def new_synset(self):
		h = self.history()
		#storage = Storage()
		new_synset_command = NewSynsetCommand(h, self.lang, self)
##		self.commands.append(new_synset_command)
		new_synset_command.redo()
	def open_child(self, ling):
		h = self.history()
		open_command = EditInnerLingCommand(h, self, self.ling, ling)
##		self.commands.append(open_command)
		open_command.redo()
	def clone(self, ling):
		cloning = ling.cloning(self.lang)
		if cloning:
			self.refresh(VMessage(ling))
		else:
			self._clone(ling)
	def _clone(self, ling):
		synset = ling.synset()
		clone_command = Clone(self.history(), self, synset, self.lang)
		clone_command.redo()
	def view(self, v):
		if self.current_vh != v:
			self.switch()
#Todo
